import sys
import shutil
import os
import signal
import subprocess
import time
import twill
import urllib2

WCS_SRCDIR = '../'
WCSCTL = '../wcsctl.py'
WCS_DATA_DIR = os.path.abspath('../data')

pids = []

def waitforport(port, start):
    while True:
        if time.time() - start > 90:
            raise Exception('Servers did not start in 90 seconds!!')
        time.sleep(1)
        try:
            urllib2.urlopen('http://localhost:%s' % port)
        except urllib2.URLError:
            continue
        else:
            break

def setup():
    twill.commands.reset_browser()
    twill.set_output(file('/dev/null', 'w'))

    if os.path.exists('/tmp/.tests'):
        shutil.rmtree('/tmp/.tests')
    os.mkdir('/tmp/.tests')
    wcs_command = [WCSCTL, 'start',
            '--app-dir', '/tmp/.tests/',
            '--data-dir', WCS_DATA_DIR,
            '--port', '10003', '--http', '--silent']
    sp = subprocess.Popen(wcs_command)
    pids.append(sp.pid)

    # Wait for the daemons to load themselves
    starttime = time.time()
    waitforport(10003, starttime)


def teardown():
    for pid in pids:
        try:
            # valgrind seems to prefer SIGINT to SIGTERM
            os.kill(pid, signal.SIGINT)
        except OSError:
            print >> sys.stderr, 'failed to kill pid %s' % pid
    #shutil.rmtree('/tmp/.tests')

