import twill
import datetime

import utils

def setup():
    '''Set up test form allowing draft'''
    utils.login('admin')
    twill.execute_string('''
go http://localhost:10003/admin/forms/new
fv 1 name draft
submit

fv 1 label name
submit

fv 1 label name2
submit

go http://localhost:10003/admin/forms/1/edit
fv 1 allow_drafts True
submit
''')
    utils.logout()

def teardown():
    '''Tear down form'''
    utils.login('admin')
    twill.execute_string('''
go http://localhost:10003/admin/forms/1/delete
submit
''')
    utils.logout()

def test_draft_require_session():
    '''Draft: session required'''
    twill.commands.reset_browser()
    twill.commands.go('http://localhost:10003/draft')
    assert(not 'savedraft' in twill.commands.browser.get_html())

def test_draft_save():
    '''Draft: save'''
    utils.login('test')
    twill.execute_string('''
go http://localhost:10003/draft
fv 1 f1 Plip
fv 1 f2 Plop
submit savedraft
''')
    utils.logout()

def test_draft_restore():
    '''Draft: restore'''
    utils.login('test')
    twill.execute_string('''
go http://localhost:10003/
find 'Your Current Drafts'
go http://localhost:10003/draft/1
find Plip
find Plop
''')
    utils.logout()

def test_draft_save_incomplete():
    '''Draft: save'''
    utils.login('test')
    twill.execute_string('''
go http://localhost:10003/draft
fv 1 f1 Plip
submit savedraft
''')
    utils.logout()

def test_draft_restore_incomplete():
    '''Draft: restore'''
    utils.login('test')
    twill.execute_string('''
go http://localhost:10003/
find 'Your Current Drafts'
go http://localhost:10003/draft/1
find Plip
''')
    utils.logout()

