import twill
import os

import utils

def setup():
    '''Set up test form'''
    utils.login('admin')
    twill.execute_string('''
go http://localhost:10003/admin/forms/new
fv 1 name file-name
submit

fv 1 label file
fv 1 type 'File Upload'
submit

fv 1 label text
fv 1 type 'Text (line)'
submit
''')

def teardown():
    '''Tear down form'''
    twill.execute_string('''
go http://localhost:10003/admin/forms/1/delete
submit
''')
    utils.logout()

def test_fill_form():
    '''File widget: fill a form, then go back and ask for the same file, with an error

       http://lists.labs.libre-entreprise.org/pipermail/wcs-devel/2009-October/000322.html
       '''
    file('/tmp/.tests/upload.txt', 'w').write('Hello World')
    twill.execute_string('''
go http://localhost:10003/file-name
formfile 1 f1$file /tmp/.tests/upload.txt
fv 1 f2 name
submit
submit previous
fv 1 f1$orexisting True
fv 1 f2 ''
submit
find 'errors processing your form'
''')
    os.unlink('/tmp/.tests/upload.txt')

